<?php

// TODO clean code
class Vector_Integration {

    // Config Here
    public $lhc;
    public $max_pages;
    public $website;
    public $currency_symbol;
    public function __construct() {
        add_action('admin_menu', [$this, 'add_admin_menu']);

        $this->lhc = new LHC_Auth_Client("https://chat.chatzio.com/restapi/","lhc_admin","48tTH6KTz4xt");
        $this->init_actions();
        $this->max_pages = 15;
        $this->website = new Web_Content();
        $this->currency_symbol = get_woocommerce_currency_symbol();
    }

    public function add_admin_menu() {
        add_menu_page(
            'Chatzio',
            'Chatzio',
            'manage_options',
            'chatzio-integration',
            [$this, 'settings_page'],
            'dashicons-admin-generic',
            2
        );

        add_submenu_page(
            'chatzio-integration',       
            'Manage Pages',          
            'Manage Pages',
            'manage_options',
            'chatzio-manage-page', 
            [$this, 'manage_page'] 
        );

        add_submenu_page(
            'chatzio-integration',       
            'Manage Posts',          
            'Manage Posts',
            'manage_options',
            'chatzio-manage-post', 
            [$this, 'manage_post'] 
        );

        add_submenu_page(
            'chatzio-integration',       
            'Manage Products',          
            'Manage Products',
            'manage_options',
            'chatzio-manage-product', 
            [$this, 'manage_product_page'] 
        );
    }

    public function init_actions() {
        // add action for inserting the chatzio widget
        add_action( 'wp_head', array($this, 'chatzio_chat'), 0);
        add_action( 'wp_trash_post', array($this, 'remove_on_pinecone'));
        add_action( 'save_post', array($this, 'update_on_pinecone') );


        // add action for ajax call
        add_action('wp_ajax_NB_sync_posts_ajax', array($this, 'get_wp_posts_ajax_callback'));
        add_action('wp_ajax_NB_sync_pages_ajax', array($this, 'get_wp_pages_ajax_callback'));
        add_action('wp_ajax_NB_rem_pages_ajax', array($this, 'get_wp_none_publish_pages_ajax_callback'));
        add_action('wp_ajax_NB_sync_products_ajax', array($this, 'get_woo_products_ajax_callback'));
        add_action('wp_ajax_NB_update_pinecone_ajax', array($this, 'update_on_pinecone_ajax_callback'));

    }

    public function lhc_login_user($email, $password) {
        $data = array(
            'username' => $email,
            'password' => $password
        );
        return $this->lhc->post_form_data('login', $data);
    }

    public function lhc_get_user_details($email) {
        return $this->lhc->get('getuser?email='.$email);
    }

    public function manage_page() {
        include_once(NB_VECTOR_PATH . 'templates/manage-page.php');
    }

    public function manage_post() {
        include_once(NB_VECTOR_PATH . 'templates/manage-post.php');
    }

    public function manage_product_page() {
        include_once(NB_VECTOR_PATH . 'templates/manage-product.php');
    }

    public function settings_page() {
        include_once(NB_VECTOR_PATH . 'templates/settings.php');
    }

    // TODO clean code
    public function get_wp_posts_ajax_callback() {

        
        $per_page = $this->max_pages; // Number of products per batch. Adjust as needed.
        $paged = isset($_GET['paged']) ? intval($_GET['paged']) : 1;  // Get the page number from the AJAX request or start with the first page.

        $exclude_posts      = get_option('exclude_posts_'.$paged, );
        if(!empty($exclude_posts != "")) {
            $exclude_posts = json_decode($exclude_posts);
        } else {
            $exclude_posts = array();
        }

        $args = array(
            'post_type'      => 'post',
            'posts_per_page' => $per_page,
            'paged'          => $paged,
            'post_status'    => 'publish'
        );

        $posts_query = new WP_Query($args);

        if (!$posts_query->have_posts()) {
            update_option('lhc_posts_synced', '1');
            wp_send_json(['success' => false, 'message' => 'No more posts to process.']); 
            exit;
        }

        while ($posts_query->have_posts()): $posts_query->the_post();
            // get post id
            $post_id = get_the_ID();

            if(in_array($post_id, $exclude_posts)) {
                $this->upload_data_to_pinecone($post_id, "-", 'post');
                continue;
            } else {
                // Access and process the post details here.
                $post_url = get_permalink($post_id);
                $title   = strip_tags(get_the_title());
                $content = strip_tags(strip_shortcodes(get_the_content()));
                $content = preg_replace("/\t+/", " ", $content);

                // concatenate in one variable with label
                $post_content = " Start Post with Title: $title   ";
                $post_content .= ' Post '.$title.' URL: ' . $post_url . "   ";
                $post_content .= ' Post Title: ' . $title . "   ";
                $post_content .= ' Post Content: ' . $content . "   ";
                $post_content .= " End Post with Title: $title   ";
                $this->upload_data_to_pinecone($post_id, $post_content, 'post');
            }
            
        endwhile;

        wp_reset_postdata();

        wp_send_json(['success' => true, 'next_page' => ($paged + 1)]);
        exit;
    }

    // TODO clean code

    public function update_on_pinecone_ajax_callback() {
        $post_id = isset($_POST['post_id']) ? intval($_POST['post_id']) : 1;
        $exclude = isset($_POST['exclude']) ? intval($_POST['exclude']) : 0;
        $this->update_on_pinecone($post_id, $exclude);
    }

    public function get_wp_pages_ajax_callback() {

        $per_page = $this->max_pages; // Number of products per batch. Adjust as needed.
        $paged = isset($_GET['paged']) ? intval($_GET['paged']) : 1;  // Get the page number from the AJAX request or start with the first page.

        $exclude_pages      = get_option('exclude_pages_'.$paged, "");
        if(!empty($exclude_pages)) {
            $exclude_pages = json_decode($exclude_pages);
        } else {
            $exclude_pages = array();
        }

        $args = array(
            'post_type'      => 'page',
            'posts_per_page' => $per_page,
            'paged'          => $paged,
            'post_status'    => 'publish'
        );
        
        $pages_query = new WP_Query($args);

        if (!$pages_query->have_posts()) {
            update_option('lhc_pages_synced', '1');
            wp_send_json(['success' => false, 'message' => 'No more pages to process.']); 
            exit;
        }

        $page_data = [];

        while ($pages_query->have_posts()): $pages_query->the_post();
            // get post id
            $page_id = get_the_ID();

            if (in_array($page_id, $exclude_pages)) {
                $this->upload_data_to_pinecone($page_id, "-", 'page');
                continue;
            } else {
                // Access and process the page details here.
                $page_url = get_permalink($page_id);
                $title   = strip_tags(get_the_title());
                $content = strip_tags(strip_shortcodes(get_the_content()));
                $content = preg_replace("/\t+/", " ", $content);

                // concatenate in one variable with label
                $page_content = " Start Page with Title: $title   ";
                $page_content .= ' Page '.$title.' URL: ' . $page_url . "   ";
                $page_content .= ' Page Title: ' . $title . "   ";
                $page_content .= ' Page Content: ' . $content . "   ";
                $page_content .= " End Page with Title: $title   ";
                
                $page_data[] = $page_content;

                $this->upload_data_to_pinecone($page_id, $page_content, 'page');
            }
            
        endwhile;

        wp_reset_postdata();

        wp_send_json(['success' => true, 'next_page' => ($paged + 1), 'data' => $page_data]);
        exit;
    }

    // get all status except publish for worpdress pages
    public function get_wp_none_publish_pages_ajax_callback() {

        
        $args = array(
            'post_type'      => 'page',
            'posts_per_page' => -1,
            'post_status'    => array('draft', 'pending', 'trash', 'auto-draft', 'future', 'private')
        );

        $pages_query = new WP_Query($args);
        if (!$pages_query->have_posts()) {
            wp_send_json(['success' => false, 'message' => 'No more pages to remove on pinecone.']); 
            exit;
        }

        while ($pages_query->have_posts()): $pages_query->the_post();
            // get post id
            $page_id = get_the_ID();
            // remove them on pinecone
            $this->upload_data_to_pinecone($page_id, "-", 'page');
        endwhile;
        wp_reset_postdata();

        wp_send_json(['success' => true]);
        exit;
    }

    public function get_combined_description($parent_product_id) {
        $parent_product = wc_get_product($parent_product_id);
        if (!$parent_product || $parent_product->get_type() != 'variable') return "";
    
        $variations = $parent_product->get_children();
        $descriptions = [];
    
        foreach ($variations as $variation_id) {
            $variation = wc_get_product($variation_id);
            $descriptions[] = strip_tags($variation->get_description());
        }
    
        // Assuming all descriptions start and end similarly, but may have differences in the middle
        // This method finds the common starting and ending words
        $first_description = $descriptions[0];
        $start_common = "";
        $end_common = "";
    
        foreach ($descriptions as $description) {
            // Find common starting string
            for ($i = 0; $i < min(strlen($first_description), strlen($description)); $i++) {
                if ($first_description[$i] == $description[$i]) {
                    $start_common .= $first_description[$i];
                } else {
                    break;
                }
            }
    
            // Find common ending string
            for ($i = 0; $i < min(strlen($first_description), strlen($description)); $i++) {
                if ($first_description[strlen($first_description) - 1 - $i] == $description[strlen($description) - 1 - $i]) {
                    $end_common = $first_description[strlen($first_description) - 1 - $i] . $end_common;
                } else {
                    break;
                }
            }
        }
    
        return trim($start_common) . " ... " . trim($end_common);
    }
    

    // process products by batch
    public function get_woo_products_ajax_callback() {

        $per_page = $this->max_pages; // Number of products per batch. Adjust as needed.
        $paged = isset($_GET['paged']) ? intval($_GET['paged']) : 1;  // Get the page number from the AJAX request or start with the first page.
    
        $exclude_products      = get_option('exclude_products_'.$paged, "");
        if(!empty($exclude_products)) {
            $exclude_products = json_decode($exclude_products);
        } else {
            $exclude_products = array();
        }

        $args = array(
            'post_type'      => array('product'),
            'posts_per_page' => $per_page,
            'paged'          => $paged,
            'post_status'    => 'publish'
        );
    
        $products = new WP_Query($args);
        $products_data = [];
    
        if (!$products->have_posts()) {
            update_option('lhc_products_synced', '1');
            wp_send_json(['success' => false, 'message' => 'No products to process.']); 
            exit;
        }

        $all_product_details = "";

        $weight_unit = get_option('woocommerce_weight_unit','lbs');
        $dimension_unit = get_option('woocommerce_dimension_unit','in');
        $child_triggered = 0;
        $products_data = array();
        while ($products->have_posts()): $products->the_post();
            $product_id = get_the_ID();

            if(in_array($product_id, $exclude_products)) {
                continue;
            }
            
            $product = wc_get_product($product_id);

            // Product URL
            $product_url = get_permalink($product_id);

            // Product Title
            $title = strip_tags($product->get_name());

            $child_data = "";
            
            // check if product has child products
            if ( $product->get_type() == 'variable' ) {
                foreach ( $product->get_children() as $child_id ) {
                    // Get the child product object
                    $variation = wc_get_product( $child_id );

                    // Get variation data
                    $variation_name = $variation->get_name();
                    $variation_price = $variation->get_price();

                    // Weight and its unit
                    $weight = $variation->get_weight();
                    
                    // Dimensions and their unit
                    $length = $variation->get_length();
                    $width = $variation->get_width();
                    $height = $variation->get_height();

                    // Child Product Attributes
                    $attributes_data = array();
                    $attributes = $variation->get_attributes();
                    foreach ($attributes as $key => $attribute) {
                        if(is_string($attribute)) {
                            $attributes_data[$key] = $attribute;
                        } else {
                            $attributes_data[$attribute->get_name()] = $product->get_attribute($attribute->get_name());
                        }
                    }

                    $categories = wp_get_post_terms($child_id, 'product_cat');
                    $category_names = array();
                    foreach ($categories as $category) {
                        $category_names[] = $category->name;
                    }

                    $child_data .= " Start Variation details for " . $variation_name . " with price: " . $variation_price . ", that belongs to product: " . $title;
                    $child_data .= " with attributes: " . json_encode($attributes_data) . " , ";
                    $child_data .= " with categories: " . json_encode($category_names) . " , ";
                    $child_data .= " with weight: $weight $weight_unit , ";
                    $child_data .= " with length: $length $dimension_unit , ";
                    $child_data .= " with width: $width $dimension_unit , ";
                    $child_data .= " with height: $height $dimension_unit . ";
                    $child_data .= " End Variation details for " . $variation_name . ". ";

                    // clear the child product on pinecone
                    $this->upload_data_to_pinecone($child_id, '-', 'product');
                    $child_triggered++;
                }
            }

           
            // Product Description
            $description = strip_tags($product->get_description());

            // more description
            $more_description = $this->get_combined_description($product_id);


            // Product Short Description
            $short_description = strip_tags($product->get_short_description());

            // Product Price
            $price = $product->get_price();

            // Sale Price
            $sale_price = $product->get_sale_price();
            if (!$sale_price) {
                $sale_price = '';
            }

            // Product Quantity (Stock)
            $stock_quantity = $product->get_stock_quantity();

            // Product SKU
            $sku = $product->get_sku();

            // Product Images
            $image_ids = $product->get_gallery_image_ids();
            $images = array();

            // Add main featured image to the start of the gallery
            $featured_image_id = $product->get_image_id();
            if ($featured_image_id) {
                $images[] = wp_get_attachment_url($featured_image_id);
            }

            foreach ($image_ids as $id) {
                $images[] = wp_get_attachment_url($id);
            }

            // Product Attributes
            $attributes_data = array();
            $attributes = $product->get_attributes();
            foreach ($attributes as $key => $attribute) {
                if(is_string($attribute)) {
                    $attributes_data[$key] = $attribute;
                } else {
                    $attributes_data[$attribute->get_name()] = $product->get_attribute($attribute->get_name());
                }
            }

            // Upsells
            $upsell_ids = $product->get_upsell_ids();
            $upsell_urls = array_map(function($id) {
                return get_permalink($id);
            }, $upsell_ids);

            // Cross-sells
            $cross_sell_ids = $product->get_cross_sell_ids();
            $cross_sell_urls = array_map(function($id) {
                return get_permalink($id);
            }, $cross_sell_ids);

            // External URL (only for 'external' product types)
            $external_url = $product->get_type() == 'external' ? $product->get_product_url() : "Not an external product";

            // Weight and its unit
            $weight = $product->get_weight();
            

            // Dimensions and their unit
            $length = $product->get_length();
            $width = $product->get_width();
            $height = $product->get_height();
            

            // Product Categories
            $categories = wp_get_post_terms($product_id, 'product_cat');
            $category_names = array();
            foreach ($categories as $category) {
                $category_names[] = $category->name;
            }
            
            // create a more descriptive details for the parent product
            $product_details = " Start with the details for the parent product: " . $title . ", ";
            $product_details .= " with details for the child products: " . $child_data . ", ";
            $product_details .= " with product url: " . $product_url . ", ";
            $product_details .= " with price: " . $price . ", ";
            if($sale_price !== "") {
                $product_details .= " with sale price: " . $sale_price . ", ";
            }
            $product_details .= " with currency symbol: " . $currency_symbol . ", ";
            $product_details .= " with attributes: " . json_encode($attributes_data) . " , ";
            $product_details .= " with categories: " . json_encode($category_names) . " , ";
            $product_details .= " with weight: $weight $weight_unit , ";
            $product_details .= " with length: $length $dimension_unit , ";
            $product_details .= " with width: $width $dimension_unit , ";
            $product_details .= " with height: $height $dimension_unit . ";
            $product_details .= " with description: " . $description . ", ";
            $product_details .= " with short description: " . $short_description . ", ";
            $product_details .= " with more description: " . $more_description . ", ";
            $product_details .= " with sku: " . $sku . ", ";
            
            $product_details .= "Upsell Product URLs:";
            foreach ($upsell_urls as $url) {
                $product_details .= " $url ";
            }
            // For Cross-sells
            $product_details .= ". Cross-sell Product URLs:";
            foreach ($cross_sell_urls as $url) {
                $product_details .= " $url ";
            }
            // For External URL
            $product_details .= ". External URL: $external_url .";
            $product_details .= " End with the details of parent product: " . $title . ". ";

            $this->upload_data_to_pinecone($product_id, "-", "product");
            $products_data[] = $product_details;
            $all_product_details .= $product_details;
        endwhile;

        $this->upload_data_to_pinecone("all_products_".$paged, $all_product_details, "product");
    
        wp_reset_postdata();
    
        wp_send_json(['success' => true, 'next_page' => ($paged + 1), 'child_triggered: ' . $child_triggered, 'data' => $products_data]);
        exit;
    }

    public function upsert_db($vector_id, $content, $email) {
        $url = 'https://chatgpt-retrieval.chatzio.com/api/vector/upsert_db';
    
        $data = array(
            'vector_id' => $vector_id,
            'content' => $content,
            'email' => $email
        );
    
        $options = array(
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_POST => true,
            CURLOPT_POSTFIELDS => json_encode($data),
            CURLOPT_HTTPHEADER => array('Content-Type: application/json')
        );
    
        $ch = curl_init($url);
        curl_setopt_array($ch, $options);
        $response = curl_exec($ch);
    
        if (curl_errno($ch)) {
            echo 'Error:' . curl_error($ch);
        }
    
        curl_close($ch);
    
        return $response;
    }

    public function upload_data_to_pinecone($id, $content, $type = "product") {
        $lhc_department_id = get_option('lhc_department_id', '');
        $key = "";
        if($lhc_department_id !== '') {
            // upload to vector the data
            $key = "dept_".$lhc_department_id;
        }

        if($key !== ""){
            $email = $key."@chatzio.com";
            
            $product_key = $key."_".$type."_".$id;

            $this->upsert_db($product_key, $content, $email);
        }
    }

    public function remove_on_pinecone( $post_id ) {
        $post_type = get_post_type( $post_id );
        $this->upload_data_to_pinecone($post_id, "-", $post_type);
    }

    public function update_on_pinecone( $post_id, $exclude = 0 ) {

        // If this is just a revision or autosave don't process the request.
        if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) 
            return $post_id;

        if($exclude == 1) {
            $this->remove_on_pinecone( $post_id );
            return $post_id;
        }

        $post_type = get_post_type( $post_id );
        if($post_type !== "product") {
            $page_url = get_permalink($post_id);
            $title   = strip_tags(get_the_title($post_id));
            $content = strip_tags(strip_shortcodes(get_the_content($post_id)));
            $content = preg_replace("/\t+/", " ", $content);

            // concatenate in one variable with label
            $page_content = " Start ".$post_type." with Title: $title   ";
            $page_content .= ' '.$post_type.' '.$title.' URL: ' . $page_url . "   ";
            $page_content .= ' '.$post_type.' Title: ' . $title . "   ";
            $page_content .= ' '.$post_type.' Content: ' . $content . "   ";
            $page_content .= " End ".$post_type." with Title: $title   ";
    
            // TODO include all other meta data

            $this->upload_data_to_pinecone($post_id, $page_content, $post_type);
        } else {
            $product = wc_get_product($post_id);
            $product_id = $product->get_id();
            $child_triggered = 0;
            $child_data = "";
            
            // check if product has child products
            if ( $product->get_type() == 'variable' ) {
                foreach ( $product->get_children() as $child_id ) {
                    // Get the child product object
                    $variation = wc_get_product( $child_id );

                    // Get variation data
                    $variation_name = $variation->get_name();
                    $variation_price = $variation->get_price();

                    // Product Description
                    $description = strip_tags($variation->get_description());

                    // Product Short Description
                    $short_description = strip_tags($variation->get_short_description());

                    // Weight and its unit
                    $weight = $variation->get_weight();
                    
                    // Dimensions and their unit
                    $length = $variation->get_length();
                    $width = $variation->get_width();
                    $height = $variation->get_height();

                    // Child Product Attributes
                    $attributes_data = array();
                    $attributes = $variation->get_attributes();
                    foreach ($attributes as $key => $attribute) {
                        if(is_string($attribute)) {
                            $attributes_data[$key] = $attribute;
                        } else {
                            $attributes_data[$attribute->get_name()] = $product->get_attribute($attribute->get_name());
                        }
                    }

                    $categories = wp_get_post_terms($child_id, 'product_cat');
                    $category_names = array();
                    foreach ($categories as $category) {
                        $category_names[] = $category->name;
                    }

                    $child_data .= " Start Variation Name: " . $variation_name . "   ";
                    $child_data .= " Variation Description: " . $description . "   ";
                    $child_data .= " Variation Short Description: " . $short_description . "   ";
                    $child_data .= " Variation Price: " . $variation_price . "   ";
                    $child_data .= " Variation Attributes: " . json_encode($attributes_data) . "   ";
                    $child_data .= " Weight: $weight $weight_unit    ";
                    $child_data .= " Length: $length $dimension_unit    ";
                    $child_data .= " Width: $width $dimension_unit    ";
                    $child_data .= " Height: $height $dimension_unit    ";
                    $child_data .= " Categories: " . json_encode($category_names) . "   ";
                    $child_data .= " End Variation Name: " . $variation_name . "   ";

                    // clear the child product on pinecone
                    $this->upload_data_to_pinecone($child_id, '-', 'product');
                    $child_triggered++;
                }
            }

            // Product URL
            $product_url = get_permalink($product_id);

            // Product Title
            $title = strip_tags($product->get_name());

            // Product Description
            $description = strip_tags($product->get_description());

            // Product Short Description
            $short_description = strip_tags($product->get_short_description());

            // Product Price
            $price = $product->get_price();

            // Sale Price
            $sale_price = $product->get_sale_price();
            if (!$sale_price) {
                $sale_price = '';
            }

            // Product Quantity (Stock)
            $stock_quantity = $product->get_stock_quantity();

            // Product SKU
            $sku = $product->get_sku();

            // Product Images
            $image_ids = $product->get_gallery_image_ids();
            $images = array();

            // Add main featured image to the start of the gallery
            $featured_image_id = $product->get_image_id();
            if ($featured_image_id) {
                $images[] = wp_get_attachment_url($featured_image_id);
            }

            foreach ($image_ids as $id) {
                $images[] = wp_get_attachment_url($id);
            }

            // Product Attributes
            $attributes_data = array();
            $attributes = $product->get_attributes();
            foreach ($attributes as $key => $attribute) {
                if(is_string($attribute)) {
                    $attributes_data[$key] = $attribute;
                } else {
                    $attributes_data[$attribute->get_name()] = $product->get_attribute($attribute->get_name());
                }
            }

            // Upsells
            $upsell_ids = $product->get_upsell_ids();
            $upsell_urls = array_map(function($id) {
                return get_permalink($id);
            }, $upsell_ids);

            // Cross-sells
            $cross_sell_ids = $product->get_cross_sell_ids();
            $cross_sell_urls = array_map(function($id) {
                return get_permalink($id);
            }, $cross_sell_ids);

            // External URL (only for 'external' product types)
            $external_url = $product->get_type() == 'external' ? $product->get_product_url() : "Not an external product";

            // Weight and its unit
            $weight = $product->get_weight();
            

            // Dimensions and their unit
            $length = $product->get_length();
            $width = $product->get_width();
            $height = $product->get_height();
            

            // Product Categories
            $categories = wp_get_post_terms($product_id, 'product_cat');
            $category_names = array();
            foreach ($categories as $category) {
                $category_names[] = $category->name;
            }
            
            // Concatenate into a string and upload to pinecone
            $product_details = " Start Product Details of Product Name: " . $title. " ";
            $product_details .= " Product ".$title ." URL: $product_url ";
            $product_details .= " Attributes:";
            foreach ($attributes_data as $key => $value) {
                $product_details .= "$key: $value";
            }
            $product_details .= " Child Products". $child_data. " ";
            $product_details .= " SKU: $sku ";
            $product_details .= " Product Name: $title ";
            $product_details .= " Description: $description ";
            $product_details .= " Short Description: $short_description ";
            $product_details .= " Price: $price ";
            $product_details .= " Sale Price: $sale_price ";
            $product_details .= " Currency Symbol: $currency_symbol ";
            $product_details .= " Weight: $weight $weight_unit ";
            $product_details .= " Length: $length $dimension_unit ";
            $product_details .= " Width: $width $dimension_unit ";
            $product_details .= " Height: $height $dimension_unit ";
            $product_details .= " Categories: " . implode(', ', $category_names). " ";

            // For Upsells
            $product_details .= "Upsell Product URLs:";
            foreach ($upsell_urls as $url) {
                $product_details .= " $url ";
            }
            // For Cross-sells
            $product_details .= "Cross-sell Product URLs:";
            foreach ($cross_sell_urls as $url) {
                $product_details .= " $url ";
            }
            // For External URL
            $product_details .= " External URL: $external_url ";
            $product_details .= " End Product Details of Product Name: " . $title . " ";

            $this->upload_data_to_pinecone($product_id, $product_details, "product");


        }
    }
    

    public function chatzio_chat() {
        $lhc_department_id  = get_option('lhc_department_id', 'None');
        if($lhc_department_id !== "None") {
        ?>
<script>
var LHC_API = LHC_API || {};
LHC_API.args = {
    mode: 'widget',
    lhc_base_url: '//chat.chatzio.com/index.php/',
    wheight: 450,
    wwidth: 350,
    pheight: 520,
    pwidth: 500,
    // fresh: true,
    leaveamessage: true,
    department: ["<?php echo $lhc_department_id?>"],
    theme: "<?php echo $lhc_department_id?>",
    check_messages: false
};
(function() {
    var po = document.createElement('script');
    po.type = 'text/javascript';
    po.setAttribute('crossorigin', 'anonymous');
    po.async = true;
    var date = new Date();
    po.src = '//chat.chatzio.com/design/defaulttheme/js/widgetv2/index.js?' + ("" + date.getFullYear() + date
        .getMonth() + date.getDate());
    var s = document.getElementsByTagName('script')[0];
    s.parentNode.insertBefore(po, s);
})();
</script>
<?php
        }
    }
}