<?php
/*
    Plugin Name: NB Vector Integration
    Description: Provides an integration with Chatzio.com and Pinecone's Vector API
    Version: 1.1.2
    Author: Nexusbond
    Author URI: https://nexusbond.com
    License: GPLv2 or later
    Text Domain: nb-vector
*/

defined('ABSPATH') || die('No direct script access allowed!');

define('NB_VECTOR_PATH', plugin_dir_path(__FILE__));
define('NB_VECTOR_URL', plugin_dir_url(__FILE__));
include_once(ABSPATH . 'wp-admin/includes/plugin.php');
include_once(NB_VECTOR_PATH . 'includes/class-lhc-integration.php');
include_once(NB_VECTOR_PATH . 'includes/class-website-content.php');
include_once(NB_VECTOR_PATH . 'includes/class-vector-integration.php');

function initialize_vector_credentials() {
    new Vector_Integration();
}

add_action('init', 'initialize_vector_credentials');


add_action('admin_enqueue_scripts', 'nb_vectors_admin_styles');

function nb_vectors_admin_styles() {
    wp_enqueue_style('nb-vectors-styles', plugins_url('templates/css/admin-style.css', NB_VECTOR_PATH . 'nb-vectors.css'), array(), '1.0.2');
}


function chatzio_enqueue_custom_fonts() {
    // Enqueue Public Sans font
    wp_enqueue_style('public-sans-font', 'https://fonts.googleapis.com/css2?family=Public+Sans:wght@400;500;600;700&display=swap', array(), null);
    
     // Enqueue Inter font
     wp_enqueue_style('inter-font', 'https://fonts.googleapis.com/css2?family=Inter:wght@400;500;600;700&display=swap', array(), null);
    
    // Enqueue Poppins font
    wp_enqueue_style('poppins-font', 'https://fonts.googleapis.com/css2?family=Poppins:wght@400;500;600;700&display=swap', array(), null);
}
add_action('wp_enqueue_scripts', 'chatzio_enqueue_custom_fonts');