<?php 

$pages = $this->website->get_all_pages();
$posts = $this->website->get_all_posts();

if (isset($_POST['exclude_content_nonce']) && wp_verify_nonce($_POST['exclude_content_nonce'], 'save_exclude_content')) {
    if(isset($_POST['page'])) {
        $selected_pages = $_POST['page'];
        if(count($selected_pages) > 0) {
            $exclude_pages = json_encode($selected_pages);
            update_option('exclude_pages', $exclude_pages);
            foreach($selected_pages as $page_id) {
                $this->remove_on_pinecone($page_id);
            }
            echo '<div class="updated"><p>Excluded pages updated!</p></div>';
           
        }
    }

    if(isset($_POST['post'])) {
        $selected_posts = $_POST['post'];
        if(count($selected_posts) > 0) {
            $exclude_posts = json_encode($selected_posts);
            update_option('exclude_posts', $exclude_posts);
            foreach($selected_posts as $post_id) {
                $this->remove_on_pinecone($post_id);
            }
            echo '<div class="updated"><p>Excluded posts updated!</p></div>';
        }
    }
}

$exclude_pages      = get_option('exclude_pages', "");
$exclude_posts      = get_option('exclude_posts', );
if(!empty($exclude_pages)) {
    $exclude_pages = json_decode($exclude_pages);
} else {
    $exclude_pages = array();
}
if(!empty($exclude_posts != "")) {
    $exclude_posts = json_decode($exclude_posts);
} else {
    $exclude_posts = array();
}

?>

<style type="text/css">
div.notice {
    display: none;
}

table#exclude-table {
    width: 100%;
}

table#exclude-table tbody tr td {
    vertical-align: top;
    border-right: 1px solid #ccc;
    padding: 5px 10px;
    width: 50%;
}

table#exclude-table tbody tr td table tr td {
    border: none;
}

div.align-right {
    text-align: right;
}
</style>
<div class="wrap">
    <h1>Exclusion of Content</h1>
    <form method="post">
        <?php wp_nonce_field('save_exclude_content', 'exclude_content_nonce'); ?>

        <table id="exclude-table">
            <thead>
                <tr>
                    <th>PAGES</th>
                    <th>POSTS</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                    <td>
                        <table>
                            <tr>
                                <td>
                                    <label>
                                        <input type="checkbox" name="page[]" value="all" />
                                        All Pages
                                    </label>
                                </td>
                            </tr>
                            <?php 
                            foreach($pages as $page): 
                                $is_selected = (in_array($page->ID, $exclude_pages)) ? "checked" : "";
                            ?>
                            <tr>
                                <td>
                                    <label>
                                        <input type="checkbox" name="page[]" value="<?php echo $page->ID; ?>"
                                            <?php echo $is_selected; ?> />
                                        <?php echo $page->post_title; ?>
                                    </label>
                                </td>
                            </tr>
                            <?php endforeach; ?>
                        </table>
                    </td>
                    <td>
                        <table>
                            <tr>
                                <td>
                                    <label>
                                        <input type="checkbox" name="post[]" value="all" />
                                        All Posts
                                    </label>
                                </td>
                            </tr>
                            <?php 
                            foreach($posts as $post): 
                                $is_selected = (in_array($post->ID, $exclude_posts)) ? "checked" : "";
                            ?>
                            <tr>
                                <td>
                                    <label>
                                        <input type="checkbox" name="post[]" value="<?php echo $post->ID; ?>"
                                            <?php echo $is_selected ?> />
                                        <?php echo $post->post_title; ?>
                                    </label>
                                </td>
                            </tr>
                            <?php endforeach; ?>
                        </table>
                    </td>
                </tr>
            </tbody>
        </table>
        <div class="align-right">
            <input type="submit" name="save_exclude_content" value="Save" class="button button-primary" />
        </div>
    </form>
</div>
<!-- jQuery for selecting all checkbox by group -->
<script type="text/javascript">
jQuery(document).ready(function($) {
    $('input[name="page[]"][value="all"]').click(function() {
        if ($(this).is(':checked')) {
            $('input[name="page[]"]').prop('checked', true);
        } else {
            $('input[name="page[]"]').prop('checked', false);
        }
    });

    $('input[name="post[]"][value="all"]').click(function() {
        if ($(this).is(':checked')) {
            $('input[name="post[]"]').prop('checked', true);
        } else {
            $('input[name="post[]"]').prop('checked', false);
        }
    });

});
</script>