<?php 

$base_url = "/wp-admin/admin.php?page=chatzio-manage-page";
$per_page = $this->max_pages;
$current_page = isset($_GET['numpage']) ? intval($_GET['numpage']) : 1;
$offset = ($current_page - 1) * $per_page;

$pages = $this->website->get_all_pages($current_page, $per_page);
$total_pages = $this->website->get_total_pages(); 
$total_pages = ceil($total_pages / $per_page);

if (isset($_POST['exclude_page_nonce']) && wp_verify_nonce($_POST['exclude_page_nonce'], 'save_exclude_page')) {
    if(isset($_POST['page'])) {
        $selected_pages = $_POST['page'];
        if(count($selected_pages) > 0) {
            $exclude_pages = json_encode($selected_pages);
            update_option('exclude_pages_'.$current_page, $exclude_pages);
            foreach($selected_pages as $page_id) {
                $this->remove_on_pinecone($page_id);
            }
            echo '<div class="updated"><p>Excluded pages updated!</p></div>';
           
        }
    }
}

$exclude_pages      = get_option('exclude_pages_'.$current_page, "");
if(!empty($exclude_pages)) {
    $exclude_pages = json_decode($exclude_pages);
} else {
    $exclude_pages = array();
}

?>

<style type="text/css">
div.notice {
    display: none;
}

table#exclude-table {
    width: 100%;
}

table#exclude-table tbody tr td {
    vertical-align: top;
    padding: 5px 10px;
    width: 50%;
}

div.align-right {
    text-align: right;
}
</style>
<div class="wrap">
    <h1>Manage Pages</h1>
    <form method="post">
        <?php wp_nonce_field('save_exclude_page', 'exclude_page_nonce'); ?>

        <table id="exclude-table">
            <tr>
                <td>
                    <label>
                        <input type="checkbox" name="page[]" value="all" />
                        Select All
                    </label>
                </td>
            </tr>
            <?php 
            foreach($pages as $page): 
                $is_selected = (in_array($page->ID, $exclude_pages)) ? "checked" : "";
            ?>
            <tr>
                <td>
                    <label>
                        <input type="checkbox" name="page[]" value="<?php echo $page->ID; ?>"
                            <?php echo $is_selected; ?> />
                        <?php echo $page->post_title; ?>
                    </label>
                </td>
            </tr>
            <?php endforeach; ?>
        </table>
        <div class="pagination">
            <?php for ($i = 1; $i <= $total_pages; $i++): ?>
            <a href="<?php echo $base_url;?>&numpage=<?php echo $i; ?>"><?php echo $i; ?></a>
            <?php endfor; ?>
        </div>
        <div class="align-right">
            <input type="submit" name="save_exclude_content" value="Save" class="button button-primary" />
        </div>
    </form>
</div>
<!-- jQuery for selecting all checkbox by group -->
<script type="text/javascript">
jQuery(document).ready(function($) {
    $('input[name="page[]"][value="all"]').click(function() {
        if ($(this).is(':checked')) {
            $('input[name="page[]"]').prop('checked', true);
        } else {
            $('input[name="page[]"]').prop('checked', false);
        }
    });
    $('input[name="page[]"]').click(function() {
        let exclude = 0
        if ($(this).is(':checked')) {
            // exclude
            exclude = 1
        }
        let post_id = $(this).val();
        // ajax call here
        $.ajax({
            url: '<?php echo admin_url('admin-ajax.php'); ?>',
            type: 'POST',
            data: {
                action: 'NB_update_pinecone_ajax',
                post_id: post_id,
                exclude: exclude
            },
            success: function(response) {
                console.log(response);
            }
        });
    });
});
</script>