<?php 

$base_url = "/wp-admin/admin.php?page=chatzio-manage-post";
$per_page = $this->max_pages;
$current_page = isset($_GET['numpage']) ? intval($_GET['numpage']) : 1;
$offset = ($current_page - 1) * $per_page;

$posts = $this->website->get_all_posts($current_page, $per_page);
$total_pages = $this->website->get_total_posts(); 
$total_pages = ceil($total_pages / $per_page);

if (isset($_POST['exclude_post_nonce']) && wp_verify_nonce($_POST['exclude_post_nonce'], 'save_exclude_post')) {
    if(isset($_POST['post'])) {
        $selected_posts = $_POST['post'];
        if(count($selected_posts) > 0) {
            $exclude_posts = json_encode($selected_posts);
            update_option('exclude_posts_'.$current_page, $exclude_posts);
            foreach($selected_posts as $post_id) {
                $this->remove_on_pinecone($post_id);
            }
            echo '<div class="updated"><p>Excluded posts updated!</p></div>';
        }
    }
}

$exclude_posts      = get_option('exclude_posts_'.$current_page, "");

if(!empty($exclude_posts != "")) {
    $exclude_posts = json_decode($exclude_posts);
} else {
    $exclude_posts = array();
}

?>

<style type="text/css">
div.notice {
    display: none;
}

table#exclude-table {
    width: 100%;
}

table#exclude-table tbody tr td {
    vertical-align: top;
    border-right: 1px solid #ccc;
    padding: 5px 10px;
    width: 50%;
}

table#exclude-table tbody tr td table tr td {
    border: none;
}

div.align-right {
    text-align: right;
}
</style>
<div class="wrap">
    <h1>Manage Posts</h1>
    <form method="post">
        <?php wp_nonce_field('save_exclude_post', 'exclude_post_nonce'); ?>
        <table id="exclude-table">
            <tr>
                <td>
                    <label>
                        <input type="checkbox" name="post[]" value="all" />
                        Select All
                    </label>
                </td>
            </tr>
            <?php 
            foreach($posts as $post): 
                $is_selected = (in_array($post->ID, $exclude_posts)) ? "checked" : "";
            ?>
            <tr>
                <td>
                    <label>
                        <input type="checkbox" name="post[]" value="<?php echo $post->ID; ?>"
                            <?php echo $is_selected ?> />
                        <?php echo $post->post_title; ?>
                    </label>
                </td>
            </tr>
            <?php endforeach; ?>
        </table>
        <div class="pagination">
            <?php for ($i = 1; $i <= $total_pages; $i++): ?>
            <a href="<?php echo $base_url;?>&numpage=<?php echo $i; ?>"><?php echo $i; ?></a>
            <?php endfor; ?>
        </div>
        <div class="align-right">
            <input type="submit" name="save_exclude_content" value="Save" class="button button-primary" />
        </div>
    </form>
</div>
<!-- jQuery for selecting all checkbox by group -->
<script type="text/javascript">
jQuery(document).ready(function($) {

    $('input[name="post[]"][value="all"]').click(function() {
        if ($(this).is(':checked')) {
            $('input[name="post[]"]').prop('checked', true);
        } else {
            $('input[name="post[]"]').prop('checked', false);
        }
    });

    $('input[name="post[]"]').click(function() {
        let exclude = 0
        if ($(this).is(':checked')) {
            // exclude
            exclude = 1
        }
        let post_id = $(this).val();
        // ajax call here
        $.ajax({
            url: '<?php echo admin_url('admin-ajax.php'); ?>',
            type: 'POST',
            data: {
                action: 'NB_update_pinecone_ajax',
                post_id: post_id,
                exclude: exclude
            },
            success: function(response) {
                console.log(response);
            }
        });
    });

});
</script>