<?php
$base_url = "/wp-admin/admin.php?page=chatzio-manage-product";
$products_per_page = $this->max_pages;
$current_page = isset($_GET['numpage']) ? intval($_GET['numpage']) : 1;
$offset = ($current_page - 1) * $products_per_page;

$products = $this->website->get_all_products($current_page, $products_per_page);
$total_pages = $this->website->get_total_products(); 
$total_pages = ceil($total_pages / $products_per_page);

if (isset($_POST['exclude_product_nonce']) && wp_verify_nonce($_POST['exclude_product_nonce'], 'save_exclude_product')) {
    if(isset($_POST['product'])) {
        $selected_products = $_POST['product'];
        if(count($selected_products) > 0) {
            $exclude_products = json_encode($selected_products);
            update_option('exclude_products_'.$current_page, $exclude_products);
            echo '<div class="updated"><p>Excluded products updated!</p></div>';
        }
    }
}

$exclude_products      = get_option('exclude_products_'.$current_page, "");
if(!empty($exclude_products)) {
    $exclude_products = json_decode($exclude_products);
} else {
    $exclude_products = array();
}
?>

<style type="text/css">
div.notice {
    display: none;
}

table#exlude-products-table {
    width: 100%;
    border-collapse: collapse;
}

table#exlude-products-table tbody tr td {
    padding: 5px 10px;
}

div.align-right {
    text-align: right;
}
</style>
<div class="wrap">
    <h1>Exclusion of Products</h1>

    <form method="post">
        <?php wp_nonce_field('save_exclude_product', 'exclude_product_nonce'); ?>
        <?php if(is_plugin_active('woocommerce/woocommerce.php')): ?>
        <table id="exlude-products-table">
            <tbody>
                <tr>
                    <td>
                        <label>
                            <input type="checkbox" name="product[]" value="all" />
                            Select All
                        </label>
                    </td>
                </tr>
                <?php 
                foreach($products as $product): 
                    $is_selected = (in_array($product->ID, $exclude_products)) ? "checked" : "";
                ?>
                <tr>
                    <td>
                        <label>
                            <input type="checkbox" name="product[]" value="<?php echo $product->ID; ?>"
                                <?php echo $is_selected; ?> />
                            <?php echo $product->post_title; ?>
                        </label>
                    </td>
                </tr>
                <?php endforeach; ?>
            </tbody>
        </table>
        <div class="pagination">
            <?php for ($i = 1; $i <= $total_pages; $i++): ?>
            <a href="<?php echo $base_url;?>&numpage=<?php echo $i; ?>"><?php echo $i; ?></a>
            <?php endfor; ?>
        </div>
        <?php endif; ?>
        <div class="align-right">
            <input type="submit" name="save_exclude_content" value="Save" class="button button-primary" />
        </div>
    </form>

</div>
<!-- jQuery for selecting all checkbox by group -->
<script type="text/javascript">
jQuery(document).ready(function($) {
    $('input[name="product"][value="all"]').click(function() {
        if ($(this).is(':checked')) {
            $('input[name="product"]').prop('checked', true);
        } else {
            $('input[name="product"]').prop('checked', false);
        }
    });

    $('input[name="product[]"]').click(function() {
        let exclude = 0
        if ($(this).is(':checked')) {
            // exclude
            exclude = 1
        }
        let post_id = $(this).val();
        // ajax call here
        $.ajax({
            url: '<?php echo admin_url('admin-ajax.php'); ?>',
            type: 'POST',
            data: {
                action: 'NB_update_pinecone_ajax',
                post_id: post_id,
                exclude: exclude
            },
            success: function(response) {
                console.log(response);
            }
        });
    });
});
</script>