<style>
#wpwrap {
    background: #F8F5FF;
}

.chatzio_main .d-none,
div.notice {
    display: none !important;
}
</style>

<script>
let pagesPercentage = 0;
let postsPercentage = 0;
let productsPercentage = 0;
</script>


<?php

if (isset($_POST['vector_credentials_nonce']) && wp_verify_nonce($_POST['vector_credentials_nonce'], 'save_vector_credentials')) {
    $email = sanitize_text_field($_POST['email_address']);
    $password = sanitize_text_field($_POST['password']);
    $check = $this->lhc_login_user($email, $password);
    
    if($email !== '' && $check['error'] == false) {
        $user = $this->lhc_get_user_details($email);
        if($user['error'] == false) {
            $result = $user['result'];
            update_option('lhc_email_address', $email);
            update_option('lhc_password', $password);
            update_option('lhc_department_id', $result['departments_ids']);
            update_option('lhc_posts_synced', '0');
            update_option('lhc_pages_synced', '0');
            update_option('lhc_products_synced', '0');
            echo '<div class="updated"><p>Credentials saved!</p></div>';
        } else {
            echo '<div class="error"><p>Invalid email: '.sanitize_text_field($_POST['email_address']).'does not exists on chatzio.com!</p></div>';
        }
    } else {
        echo '<div class="error"><p>Please check your credentials, should be the same as what you used on <a href="https://chat.chatzio.com" target="_blank">chat.chatzio.com</a>!</p></div>';
    }
}

if (isset($_POST['resync_posts_nonce']) && wp_verify_nonce($_POST['resync_posts_nonce'], 'resync_posts')) {
    if(isset($_POST['sync_posts'])) {
        update_option('lhc_posts_synced', '0');
    }
}
if (isset($_POST['resync_pages_nonce']) && wp_verify_nonce($_POST['resync_pages_nonce'], 'resync_pages')) {
    if(isset($_POST['sync_pages'])) {
        update_option('lhc_pages_synced', '0');
    }
}
if (isset($_POST['resync_products_nonce']) && wp_verify_nonce($_POST['resync_products_nonce'], 'resync_products')) {
    if(isset($_POST['sync_products'])) {
        update_option('lhc_products_synced', '0');
    }
}

//temporary for reset 
if (isset($_POST['reset_sync_all_nonce']) && wp_verify_nonce($_POST['reset_sync_all_nonce'], 'reset_sync_all')) {
    if(isset($_POST['reset_sync_all'])) {
        update_option('lhc_products_synced', '0');
        update_option('lhc_pages_synced', '0');
        update_option('lhc_posts_synced', '0');
        update_option('lhc_department_id', 'None');
    }
}

$lhc_email_address      = get_option('lhc_email_address', '');
$lhc_password           = get_option('lhc_password', '');
$lhc_department_id      = get_option('lhc_department_id', 'None');
$lhc_posts_synced       = get_option('lhc_posts_synced', '0');
$lhc_pages_synced       = get_option('lhc_pages_synced', '0');
$lhc_products_synced    = get_option('lhc_products_synced', '0');
?>

<div class="wrap chatzio_main">

    <div class="process_container">
        <div class="logo_container">
            <a href="https://chatzio.com/" target="_blank"><img width="192" height="72"
                    src="<?php echo NB_VECTOR_URL;?>assets/chatzio-logo.svg" alt="chatzio logo" /></a>
        </div>

        <!-- Step 1 -->
        <?php  if($lhc_department_id === "None"): ?>
        <div class="cz_process cz_step1">
            <div class="text_container">
                <h1 class="cz_heading">Connect your chatzio account</h1>
                <p class="cz_sub_text">Enter the credentials you used to sign up for your Chatzio plan below.</p>
            </div>
            <form method="post">
                <?php wp_nonce_field('save_vector_credentials', 'vector_credentials_nonce'); ?>
                <div class="form-container">
                    <div class="form_item">
                        <label for="email_address">Email</label>
                        <input type="text" id="lhc_email_address" name="email_address"
                            value="<?php echo esc_attr($lhc_email_address); ?>" class="regular-text">
                    </div>
                    <div class="form_item">
                        <label for="password">Password</label>
                        <input type="password" id="lhc_password" name="password"
                            value="<?php echo esc_attr($lhc_password); ?>" class="regular-text">

                    </div>
                </div>
                <div class="form_footer">

                    <button type="submit" name="submit" id="submit"
                        class="cz_btn_primary connect_btn button button-primary">Connnect
                        <span class="hover-icon">
                            <svg xmlns="http://www.w3.org/2000/svg" width="25" height="24" viewBox="0 0 25 24"
                                fill="none">
                                <path d="M5.5 12H19.5" stroke="white" stroke-width="2" stroke-linecap="round"
                                    stroke-linejoin="round" />
                                <path d="M12.5 5L19.5 12L12.5 19" stroke="white" stroke-width="2" stroke-linecap="round"
                                    stroke-linejoin="round" />
                            </svg>
                        </span>
                    </button>


                </div>
            </form>
        </div>
        <?php elseif($lhc_department_id !== "None" && $lhc_posts_synced == '0' || $lhc_pages_synced == '0' || is_plugin_active('woocommerce/woocommerce.php') && $lhc_products_synced == '0'): ?>
        <!-- Step 2 -->
        <div class="cz_process cz_step2">
            <div class="text_container">
                <p class="cz_sub_text">Chatzio is learning everything about your website :) <br> Depending on the amount
                    of data on your site, this may take a while.</p>
            </div>
            <div class="info_alert">
                <span class="info_icon">
                    <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none">
                        <path
                            d="M12 22C17.5228 22 22 17.5228 22 12C22 6.47715 17.5228 2 12 2C6.47715 2 2 6.47715 2 12C2 17.5228 6.47715 22 12 22Z"
                            stroke="white" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" />
                        <path d="M12 16H12.01" stroke="white" stroke-width="2" stroke-linecap="round"
                            stroke-linejoin="round" />
                        <path d="M12 8V12" stroke="white" stroke-width="2" stroke-linecap="round"
                            stroke-linejoin="round" />
                    </svg>
                </span>
                <span class="info_text">Do not leave this page until the process is complete!</span>
            </div>
            <div class="progress_container">
                <div class="loading-bar">
                    <div class="progress-bar_c"></div>
                </div>
            </div>
        </div>
        <?php else: ?>
        <!-- Step 3 -->
        <div class="cz_process cz_step2">
            <div class="text_container">
                <h1 class="cz_heading">Congrats, You're All Set!</h1>

                <div class="cz_bullet_p">
                    <span class="cz_bullet_icon"></span>
                    <p class="cz_sub_text">Chatzio has finished scanning your website and is live on your site ready to
                        help your visitors!</p>
                </div>
                <div class="cz_bullet_p">
                    <span class="cz_bullet_icon"></span>
                    <p class="cz_sub_text">If you’d like to remove any data from Chatzio’s knowledge base, simple click
                        on Manage Pages/Posts/Products on the left hand menu.</p>
                </div>
                <div class="cz_bullet_p">
                    <span class="cz_bullet_icon"></span>
                    <p class="cz_sub_text">To manage your active chats, manage your branding and more, login to your
                        Chatzio dashboard.</p>
                </div>
            </div>
            <div class="form_footer">
                <a href="https://chat.chatzio.com/" class="cz_btn_primary connect_btn button button-primary"
                    target="_blank">Login to Dashboard
                    <span class="hover-icon">
                        <svg xmlns="http://www.w3.org/2000/svg" width="25" height="24" viewBox="0 0 25 24" fill="none">
                            <path d="M5.5 12H19.5" stroke="white" stroke-width="2" stroke-linecap="round"
                                stroke-linejoin="round" />
                            <path d="M12.5 5L19.5 12L12.5 19" stroke="white" stroke-width="2" stroke-linecap="round"
                                stroke-linejoin="round" />
                        </svg>
                    </span>
                </a>
            </div>
        </div>
        <?php endif; ?>

    </div>



    <?php if($lhc_department_id !== "None"): ?>


    <!-- Posts Here -->
    <?php if($lhc_posts_synced == '0'): ?>
    <?php 
        $total_posts = $this->website->get_total_posts(); 
        $pages = ceil($total_posts / $this->max_pages);
    ?>

    <div class="progress d-none">
        <div class="progress-bar-container">
            <div class="progress-bar" id="posts_progress">Posts</div>
        </div>
    </div>
    <script type="text/javascript">
    jQuery(document).ready(function($) {
        var pages = <?php echo $pages; ?>;
        var page = 1;

        function fetchPosts(paged) {
            jQuery("#loader").show();
            jQuery.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                type: 'GET',
                data: {
                    action: 'NB_sync_posts_ajax',
                    paged: paged
                },
                dataType: 'json',
                success: function(response) {
                    jQuery("#loader").hide();
                    if (response.success) {

                        var percentage = (paged / pages) * 100;
                        if (percentage > 99) {
                            percentage = 99;
                        }
                        $('#posts_progress').css('width', percentage + '%');

                        postsPercentage = percentage;
                        updateGlobalProgressBar();

                        // Fetch the next batch if required
                        fetchPosts(response.next_page);
                    } else {
                        console.log('No more posts or an error occurred.');
                    }
                },
                error: function() {
                    console.log('AJAX error.');
                    location.reload(true);
                }
            });
        }
        fetchPosts(page)

    });
    </script>
    <?php else: ?>
    <form method="post" class="d-none">
        <?php wp_nonce_field('resync_posts', 'resync_posts_nonce'); ?>
        <input type="submit" name="sync_posts" value="Sync Posts" class="button button-primary button_spacing">
    </form>
    <?php endif; ?>


    <!-- Pages Here -->
    <?php if($lhc_pages_synced == '0'): ?>
    <?php 
        $total_pages = $this->website->get_total_pages(); 
        $pages = ceil($total_pages / $this->max_pages);
        ?>
    <div class="progress d-none">
        <div class="progress-bar-container">
            <div class="progress-bar" id="pages_progress">Pages</div>
        </div>
    </div>
    <script type="text/javascript">
    jQuery(document).ready(function($) {
        var pages = <?php echo $pages; ?>;
        var page = 1;

        function fetchPages(paged) {
            jQuery("#loader").show();
            jQuery.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                type: 'GET',
                data: {
                    action: 'NB_sync_pages_ajax',
                    paged: paged
                },
                dataType: 'json',
                success: function(response) {
                    jQuery("#loader").hide();
                    if (response.success) {

                        var percentage = (paged / pages) * 100;
                        if (percentage > 99) {
                            percentage = 99;
                        }
                        $('#pages_progress').css('width', percentage + '%');

                        pagesPercentage = percentage;
                        updateGlobalProgressBar();

                        // Fetch the next batch if required
                        fetchPages(response.next_page);
                    } else {
                        console.log('No more products or an error occurred.');
                    }
                },
                error: function() {
                    console.log('AJAX error.');
                    location.reload(true);
                }
            });
        }
        fetchPages(page)

        function remPages() {
            jQuery("#loader").show();
            jQuery.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                type: 'GET',
                data: {
                    action: 'NB_rem_pages_ajax',
                },
                dataType: 'json',
                success: function(response) {
                    jQuery("#loader").hide();
                    if (response.success) {
                        console.log('Pages Removed');
                    } else {
                        console.log('No more products or an error occurred.');
                    }
                },
                error: function() {
                    console.log('AJAX error.');
                }
            });
        }
        remPages();

    });
    </script>
    <?php else: ?>
    <form method="post" class="d-none">
        <?php wp_nonce_field('resync_pages', 'resync_pages_nonce'); ?>
        <input type="submit" name="sync_pages" value="Sync Pages" class="button button-primary button_spacing">
    </form>
    <?php endif; ?>


    <!-- Products Here -->
    <?php if(is_plugin_active('woocommerce/woocommerce.php') && $lhc_products_synced == '0'): ?>
    <?php 
        $total_products = $this->website->get_total_products(); 
        $pages = ceil($total_products / $this->max_pages);
        ?>
    <div class="progress d-none">
        <div class="progress-bar-container">
            <div class="progress-bar" id="product_progress">Products</div>
        </div>
    </div>
    <script type="text/javascript">
    jQuery(document).ready(function($) {
        var pages = <?php echo $pages; ?>;
        var page = 1;

        function fetchProducts(paged) {
            jQuery("#loader").show();
            jQuery.ajax({
                url: '<?php echo admin_url('admin-ajax.php'); ?>',
                type: 'GET',
                data: {
                    action: 'NB_sync_products_ajax',
                    paged: paged
                },
                dataType: 'json',
                success: function(response) {
                    jQuery("#loader").hide();
                    if (response.success) {

                        var percentage = (paged / pages) * 100;
                        if (percentage > 99) {
                            percentage = 99;
                        }
                        $('#product_progress').css('width', percentage + '%');

                        productsPercentage = percentage;
                        updateGlobalProgressBar();

                        // Fetch the next batch if required
                        fetchProducts(response.next_page);
                        console.log(percentage);
                    } else {
                        $('#product_progress').css('width', '99%');
                        console.log('No more products or an error occurred.');
                    }
                },
                error: function() {
                    console.log('AJAX error.');
                    location.reload(true);
                }
            });
        }
        fetchProducts(page)

    });
    </script>
    <?php else: ?>
    <form method="post" class="d-none">
        <?php wp_nonce_field('resync_products', 'resync_products_nonce'); ?>
        <input type="submit" name="sync_products" value="Sync Products" class="button button-primary button_spacing">
    </form>
    <?php endif; ?>

    <?php /*
    <div style="display:none;">
        <!-- Temporary for testing inly -->
        <form method="post" style="margin-top: 50px;">
            <?php wp_nonce_field('reset_sync_all', 'reset_sync_all_nonce'); ?>
    <input type="submit" name="reset_sync_all" value="Reset All and Start from Step 1"
        class="button button-primary reset_btn"
        style=" width: 100%; display: flex!important; justify-content: center; align-items: center; height: 46px!important; border-radius: 100px!important; border: 1px solid #F48120! important; background: #F48120 !important; ">
    </form>
</div> */ ?>

<script>
let combinedPercentage = 0;
let isWooActive = "<?php echo is_plugin_active('woocommerce/woocommerce.php')?>";

let lhc_pages_synced = "<?php echo $lhc_pages_synced ?>";
let lhc_posts_synced = "<?php echo $lhc_posts_synced ?>";
let lhc_products_synced = "<?php echo $lhc_products_synced?>";



function updateGlobalProgressBar() {
    let sync_processing = 0;

    // console.log("lhc_pages_synced: "+lhc_pages_synced);
    // console.log("lhc_posts_synced: "+lhc_posts_synced);
    // console.log("lhc_products_synced: "+lhc_products_synced);
    // console.log("isWooActive: "+isWooActive);

    //0 means sync is in process 
    if (lhc_pages_synced == 0) {
        ++sync_processing;
    }
    if (lhc_posts_synced == 0) {
        ++sync_processing;
    }
    if (isWooActive && lhc_products_synced == 0) {
        ++sync_processing;
    }

    console.log("sync_processing: " + sync_processing);

    combinedPercentage = (pagesPercentage + postsPercentage + productsPercentage) / sync_processing;

    console.log(combinedPercentage);

    if (combinedPercentage == 99) {
        console.log('reload');
        jQuery('.progress-bar_c').css('width', '100%');

        setTimeout(() => {
            location.reload(true);
        }, "2000");
    } else {
        jQuery('.progress-bar_c').css('width', combinedPercentage + '%');
    }
}
</script>

<?php endif; ?>
</div>